package com.example.navigationapp

import android.os.Bundle
import androidx.activity.ComponentActivity
import androidx.activity.compose.setContent
import androidx.activity.enableEdgeToEdge
import androidx.navigation.compose.NavHost
import androidx.navigation.toRoute
import androidx.navigation.compose.composable
import androidx.navigation.compose.rememberNavController
import com.example.navigationapp.screen.ScreenOne
import com.example.navigationapp.screen.ScreenTwo
import com.example.navigationapp.ui.theme.NavigationAppTheme
import kotlinx.serialization.Serializable


class MainActivity : ComponentActivity() {
    override fun onCreate(savedInstanceState: Bundle?) {
        super.onCreate(savedInstanceState)
        enableEdgeToEdge()
        setContent {
            val navController = rememberNavController()
            NavigationAppTheme{
                NavHost(navController = navController, startDestination = One(sampleText = "Screen One")){
                    composable<One>{
                        val one: One = it.toRoute()
                        ScreenOne(one) {
                            navController.navigate(route = Two)
                        }
                    }
                    composable<Two>{
                        ScreenTwo(onNavigationToScreenOne = {
                            navController.navigate(route = One("from second screen"))
                        }
                        )
                    }
                }
            }
            NavigationAppTheme {

            }
        }
    }
}

@Serializable
data class One(val sampleText: String)

@Serializable
object Two
